#!/usr/bin/env python

# Chibuzz?
# Version 0.2.x
# Sep 2008
# by Luca Forina
#
# Website: http://www.gtk-apps.org/content/show.php/ChiBuzz%3F?content=85621
# Licence: GPL v3


# Chibuzz is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3,
# as published by the Free Software Foundation.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.




import sys
import pygtk
pygtk.require("2.0")
import os.path
import gtk
import gtk.glade
from urllib2 import urlopen
import urllib2
from BeautifulSoup import BeautifulSoup
from gmaps import GoogleMaps
import commands
import locale
import socket
import threading





class chibuzz:
	def __init__ (self):
		self.locale()
		self.gui()




	#------------------------------> LOCALE
	def locale(self):
		if sys.platform == "win32":
			getlang = os.getenv('LANG')
			if getlang is None:
				getlang2 = locale.getdefaultlocale()
				getlang = str(getlang2)
				setlang = getlang[2:4]
		else:
			getlang = os.environ['LANG']
			setlang = getlang[0:2]
		if setlang == "pl":
			self.menu_exit = "Exit"
			self.menu_about = "About"
			self.tb_btn1 = "Szukaj"
			self.tb_btn2 = "Zoom Out"
			self.tb_btn3 = "Zoom In"
			self.tb_label1 = "IP address:  "
			self.tree_col1 = "Description"
			self.tree_col2 = "Value"
			self.tree_public_ip = "Publiczne IP"
			self.tree_country = "Kraj"
			self.tree_city = "Miasto"
			self.tree_state = "Stan"
			self.tree_isp = "ISP"
			self.tree_latitude = "Latitude"
			self.tree_longitude = "Longitude"
			self.tree_zip = "Zip code"
		elif setlang == "it":
			self.menu_exit = "Esci"
			self.menu_about = "Informazioni"
			self.tb_btn1 = "Avvia ricerca"
			self.tb_btn2 = "Riduci"
			self.tb_btn3 = "Ingrandisci"
			self.tb_label1 = "Indirizzo IP:  "
			self.tree_col1 = "Descrizione"
			self.tree_col2 = "Valore"
			self.tree_public_ip = "IP pubblico"
			self.tree_country = "Nazione"
			self.tree_city = "Citta'"
			self.tree_state = "Regione"
			self.tree_isp = "Provider"
			self.tree_latitude = "Latitudine"
			self.tree_longitude = "Longitudine"
			self.tree_zip = "Codice postale"
		else:
			self.menu_exit = "Exit"
			self.menu_about = "About"
			self.tb_btn1 = "Start scan"
			self.tb_btn2 = "Zoom Out"
			self.tb_btn3 = "Zoom In"
			self.tb_label1 = "IP address:  "
			self.tree_col1 = "Description"
			self.tree_col2 = "Value"
			self.tree_public_ip = "Public IP"
			self.tree_country = "Country"
			self.tree_city = "City"
			self.tree_state = "State"
			self.tree_isp = "ISP"
			self.tree_latitude = "Latitude"
			self.tree_longitude = "Longitude"
			self.tree_zip = "Zip code"




	#------------------------------> GUI
	def gui(self):
		self.xml = gtk.glade.XML (sys.path[0] + "/glade/gui.glade")
		self.win = self.xml.get_widget ("window1")
		self.win.set_resizable(True)
		self.win.connect("destroy", lambda w: gtk.main_quit())

		# rgba stuff
		if sys.platform == "linux2":
			try:
				self.gtk_screen = self.win.get_screen()
				colormap = self.gtk_screen.get_rgba_colormap()
				if colormap:
					gtk.widget_set_default_colormap(colormap)
					self.statusicon.set_visible(True)
			except:
				pass

		# get widgets
		tb_label1 = self.xml.get_widget ("tb_label1")
		self.tb_entry1 = self.xml.get_widget ("tb_entry1")
		tb_btn1 = self.xml.get_widget ("tb_btn1")
		tb_btn2 = self.xml.get_widget ("tb_btn2")
		tb_btn3 = self.xml.get_widget ("tb_btn3")
		imagemenuitem5_lbl = self.xml.get_widget ("imagemenuitem5")
		imagemenuitem5 = self.xml.get_widget ("imagemenuitem5")
		imagemenuitem10_lbl = self.xml.get_widget ("imagemenuitem10")
		self.image1 = self.xml.get_widget ("image1")
		treeView = self.xml.get_widget("treeview1")
		self.text = self.xml.get_widget ("textview1").get_buffer()
		self.statusbar = self.xml.get_widget("statusbar1")

		# set widgets
		tb_label1 = tb_label1.set_label(self.tb_label1)
		tb_btn1 = tb_btn1.set_label(self.tb_btn1)
		tb_btn2 = tb_btn2.set_label(self.tb_btn2)
		tb_btn3 = tb_btn3.set_label(self.tb_btn3)
		imagemenuitem5 = imagemenuitem5.connect("activate", lambda wid: gtk.main_quit())
		#self.imagemenuitem5_lbl = self.imagemenuitem5_lbl.set_text(self.menu_exit)
		#self.imagemenuitem10_lbl = self.imagemenuitem10_lbl.set_text(self.menu_about)
		self.image1 = self.image1.set_from_file(sys.path[0] + "/glade/maps_logo.png")

		# update statusbar
		statusbarid = self.statusbar.get_context_id("status")
		self.statusbar.push(statusbarid, "Press Start button to retrieve information")

		# define treeview
		treeView.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
		self.ll = gtk.ListStore(str,str)
		treeView.set_model(self.ll)
		crt = gtk.CellRendererText()

		# define 1st column treeview
		column1 = gtk.TreeViewColumn(self.tree_col1)
		treeView.append_column(column1)
		column1.pack_start(crt, True)
		column1.add_attribute(crt, "text", 0)
		column1.set_resizable(True)
		column1.set_sort_column_id(0)

		# define 2nd column treeview
		column2 = gtk.TreeViewColumn(self.tree_col2)
		treeView.append_column(column2)
		column2.pack_start(crt, True)
		column2.add_attribute(crt, "text", 1)

		# update 1st column treeview
		self.iter1 = self.ll.append([self.tree_public_ip,""])
		self.iter2 = self.ll.append([self.tree_country,""])
		self.iter3 = self.ll.append([self.tree_city,""])
		self.iter4 = self.ll.append([self.tree_state,""])
		self.iter5 = self.ll.append([self.tree_isp,""])
		self.iter6 = self.ll.append([self.tree_latitude,""])
		self.iter7 = self.ll.append([self.tree_longitude,""])
		self.iter8 = self.ll.append([self.tree_zip,""])

		# signal autoconnect
		dic = {	"on_tb_btn1_clicked" : self.tb_btn1_clicked,
				"on_tb_btn2_clicked" : self.tb_btn2_clicked,
				"on_tb_btn3_clicked" : self.tb_btn3_clicked,
				"on_tb_entry1_activate" : self.tb_btn1_clicked,
				"imagemenuitem5_activate_cb" : lambda wid: gtk.main_quit(),
				"imagemenuitem10_activate_cb" : self.about_menu_activate }
		self.xml.signal_autoconnect (dic)
		return




	#------------------------------> ABOUT_MENU_CLICKED
	def about_menu_activate(self,widget):
		about = gtk.glade.XML(sys.path[0] + "/glade/about.glade").get_widget("aboutdialog")
		about.show_all()
		about.run()
		about.hide_all()




	#------------------------------> TB_BTN1_CLICKED
	def tb_btn1_clicked(self,widget):
		# update statusbar
		statusbarid = self.statusbar.get_context_id("status")
		self.statusbar.push(statusbarid, "Scan in progress..")

		# start anim
		self.image1 = self.xml.get_widget ("image1")
		self.image1 = self.image1.set_from_file(sys.path[0] + "/glade/loading.gif")

		self.ipinfo()
		self.zoom=14
		self.gmap()
		self.whois()




	#------------------------------> TB_BTN2_CLICKED
	def tb_btn2_clicked(self,widget):
		self.zoom=self.zoom-1
		self.gmap()




	#------------------------------> TB_BTN3_CLICKED
	def tb_btn3_clicked(self,widget):
		self.zoom=self.zoom+1
		self.gmap()




	#------------------------------> IPINFO
	def ipinfo(self):
		# get ip from tb_entry1
		self.tb_entry1 = self.xml.get_widget ("tb_entry1")
		self.tb_entry1 = self.tb_entry1.get_text()

		if self.tb_entry1 == "localhost":
			ipa = ""
		else:
			self.ipaddrn = socket.gethostbyname (self.tb_entry1)
			ipa = "?ip="+self.ipaddrn

		# beautifulsoup html parser
		sock = urllib2.urlopen("http://geotool.servehttp.com/"+ipa)
		htmlSource = sock.read()
		sock.close()
		soup = BeautifulSoup(''.join(htmlSource))

		# IP Address
		a=soup('input')[0]['value']
		# Country:
		b=soup('b')[0]
		# State:
		c=soup('td')[20]
		# City:
		d=soup('td')[17]
		# Latitude:
		e=soup('td')[32]
		# Longitude:
		f=soup('td')[38]
		# ISP:
		g=soup('td')[8]
		# ZIP:
		h=soup('span')[1]
		# Host:
		#i=soup('a')[5]
		# Flag:
		#l=soup('a')[8]

		# washup strings
		self.i1text = a
		self.i2text = b.contents[0].strip()
		self.i3text = d.contents[0].strip()
		self.i4text = c.contents[0].strip()
		self.i5text = g.contents[0].strip()
		self.i6text = e.contents[0].strip()
		self.i7text = f.contents[0].strip()
		self.i8text = h.contents[0].strip()

		# update 2nd column treeview
		self.ll.set(self.iter1,1,self.i1text)
		self.ll.set(self.iter2,1,self.i2text)
		self.ll.set(self.iter3,1,self.i3text)
		self.ll.set(self.iter4,1,self.i4text)
		self.ll.set(self.iter5,1,self.i5text)
		self.ll.set(self.iter6,1,self.i6text)
		self.ll.set(self.iter7,1,self.i7text)
		self.ll.set(self.iter8,1,self.i8text)




	#------------------------------> GOOGLEMAPS
	def gmap(self):
		######################################################################
		self.textview1 = self.xml.get_widget ("textview1")
		self.viewport1_height = self.textview1.size_request()
		print self.viewport1_height


		image1 = GoogleMaps('ABQIAAAAtZMgQQ9dDJuMSfS-e78GphQEzmKRi1CsYcYwLx_oEw5L04j-XxT2U4ye0KBwazCzXi2pkueCm44pLg')
		# To retrive an image use the method retrieveStaticImage.
		gImage = image1.retrieveStaticImage(348, 310, self.i7text, self.i6text, self.zoom, "png32")
		# To find the geocode address use the method geocodeAddress.
		#gAddress = gmap.geocodeAddress("Street, City")
		# To get a upper view off the image, delta_x = 100 and delta_y = 0, same zoom=8.
		#tMap = gmap.adjust(gAddress[0],gAddress[1],100,0,8)
		# Retrieve the image again.
		#gImage = gmap.retrieveStaticImage(320, 240, 12.4833, 41.9000, 12, "png32")
		self.image1 = self.xml.get_widget ("image1")
		self.image1 = self.image1.set_from_file(sys.path[0] + "/glade/map.png")




	#------------------------------> WHOIS
	def whois(self):
		self.tb_entry1 = self.xml.get_widget ("tb_entry1")
		self.tb_entry1 = self.tb_entry1.get_text()

		if self.tb_entry1 == "localhost":
			ipa2 = self.i1text
		else:
			ipa2 = self.ipaddrn

		sock = urllib2.urlopen("http://www.ip-adress.com/whois/"+ipa2)
		whoisSource = sock.read()
		sock.close()
		soup2 = BeautifulSoup(''.join(whoisSource))

		# info:
		item1=soup2('font')[1]

		# whashup strings
		self.item1text = item1.contents[0]

		# update whois box
		self.text = self.xml.get_widget ("textview1").get_buffer()
		self.text = self.text.insert_at_cursor(self.item1text)

		# update statusbar
		statusbarid = self.statusbar.get_context_id("status")
		self.statusbar.push(statusbarid, "Scan completed! Ready for a new scan")




if __name__ == "__main__":
	chibuzz()
	gtk.main()
